
exports.up = function (knex, Promise) {
    return knex.schema.createTable('messages', function (table) {
        table.increments('mid'); //autoincrementing (non-nullable) primary key
        table.timestamps(true, true); //adds timestamptz-type (a PostgresQL data type) updated_at and created_at columns
        
        table.string('recipient',128).notNullable().defaultTo('noone')
            .references('gid').inTable('groups')
            .onDelete('SET DEFAULT'); //if recipient is deleted, direct to the special "no-one" group
        //'authors' can be a Group or a User, so specified in childtables.
        table.string('title').notNullable();
        table.text('content');
    });
};

exports.down = function (knex, Promise) {
    return knex.schema.dropTable('messages');
};
